//Beltrani Saele 0000311983

import java.io.*;
import java.net.*;

public class Server {

    public static void main(String[] args) {
        //interfaccia utente e con i client, gestione del sender
        ServerSocket sock = null;
        boolean ciao = false;
        boolean rightSocket = false;
        // <editor-fold defaultstate="collapsed" desc="Apertura socket">
        while (!rightSocket) {
            InetAddress addr = null;
            int port = -1;
            try {
                System.out.println("Su che porta aprire la socket?");
                BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
                port = Integer.parseInt(br.readLine());
                if (port > 65535 || port < 0) {
                    throw new NumberFormatException();
                } //if
                addr = InetAddress.getLocalHost();
                rightSocket = true;
                try {
                    sock = new ServerSocket(port);
                    sock.setReuseAddress(true);
                } catch (IOException ioex) {
                    System.out.println("Errore nella creazioen socket, termino");
                    ioex.printStackTrace();
                    System.exit(1);
                } //try-catch
            } catch (UnknownHostException uhex) {
                System.out.println("IP non riconosciuto");
                continue;
            } catch (IOException ioex) {
                System.out.println("Errore nella lettura stringa");
                continue;
            } catch (NumberFormatException nfex) {
                System.out.println("Porta non valida, deve essere un intero tra 0 e 65535");
                continue;
            } //try-catch
        } //while
        try {
            System.out.println("Server attivo su: " + InetAddress.getLocalHost().getHostAddress() + ":" + sock.getLocalPort());
        } catch (UnknownHostException uhex) {
        } //try-catch //</editor-fold>
        while (true) {
            try {
                Socket cliSock = sock.accept();
                ServerSender serv = new ServerSender(cliSock);
                serv.start();
            } catch (IOException ioex) {
                System.out.println("Errore nella gestione della richiesta");
                System.exit(1);
            } // try-catch
        }
    } //main
} //class
