//Beltrani Saele 0000311983

import java.io.*;
import java.net.Socket;
import java.util.StringTokenizer;

public class ServerSender extends Thread {
    private Socket cliSock;
    public ServerSender(Socket sock) {
        //costruttore
        cliSock = sock;
    } //ClientReceiver

    @Override
    public void run() {
        //gestione della ricezione
        while(true){
            try {
                DataInputStream in = new DataInputStream(cliSock.getInputStream());
                DataOutputStream out = new DataOutputStream(cliSock.getOutputStream());
                String toRead = in.readUTF();
                if(toRead.equals("OFF")){
                    break;
                } //if
                StringTokenizer str = new StringTokenizer(toRead, ":");
                String getPut = str.nextToken();
                if (!getPut.equals("GETDIR") && !getPut.equals("PUTDIR")) {
                    out.writeUTF("");
                    System.out.println("Errore di protocollo");
                    break;
                } //if
                if(getPut.equals("GETDIR")){
                    // <editor-fold defaultstate="collapsed" desc="Invio file">
                    File f = new File(str.nextToken());
                    if (f.isDirectory()) {
                        for (int i = 0; i < f.listFiles().length; i++) {
                            File temp = f.listFiles()[i];
                            out.writeUTF(temp.getName() + ":" + temp.length());
                            DataInputStream fIn = new DataInputStream(new FileInputStream(temp));
                            for (int c = 0; c < temp.length(); c++) {
                                out.write(fIn.read());
                                out.flush();
                            } //for
                            fIn.close();
                        } //for
                    } //if
                    out.writeUTF("");
                    out.flush(); //</editor-fold>
                } else{
                    //<editor-fold defaultstate="collapsed" desc="Ricezione file">
                    File dir = new File(str.nextToken());
                    dir.mkdir();
                    boolean everReceived = false;
                    while (true) {
                        String toReceive = in.readUTF();
                        if (toReceive.length() == 0 && everReceived) {
                            break;
                        } //if
                        everReceived = true;
                        str = new StringTokenizer(toReceive, ":");
                        String localPath = dir.getName()+java.io.File.separatorChar+str.nextToken();
                        DataOutputStream fOut = new DataOutputStream(new FileOutputStream(localPath));
                        int dim = Integer.parseInt(str.nextToken());
                        for (int i = 0; i < dim; i++) {
                            fOut.write(in.read());
                        } //for(dim)
                        fOut.close();
                    } //while(true) //</editor-fold>
                } //if-else
            } catch (Exception e) {
                e.printStackTrace();
            } //try-catch
        } //while
        try{
            cliSock.shutdownOutput();
            cliSock.close();
        } catch(IOException ioex){
            System.out.println("Problemi in chiusura, forzo la terminazione");
            System.exit(1);
        } //try-catch
    } //run
} //class

