//Beltrani Saele 0000311983
import java.io.*;
import java.net.*;
import java.util.StringTokenizer;

public class Client {

    public static void main(String[] args) {
        //interfaccia con l'utente e gestione del receiver
        DataOutputStream out = null;
        DataInputStream in = null;
        Socket sock = null;
        // <editor-fold defaultstate="collapsed" desc="Creazione socket">
        boolean rightServer = false;
        while (!rightServer) {
            InetAddress addr = null;
            int port = -1;
            try {
                System.out.println("A quale server connettersi? IP:PORT");
                BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
                String read = br.readLine();
                StringTokenizer str = new StringTokenizer(read, ":");
                if (str.countTokens() == 2) {
                    addr = InetAddress.getByName(str.nextToken());
                    port = Integer.parseInt(str.nextToken());
                    if (port > 65535 || port < 0) {
                        throw new NumberFormatException();
                    } //if
                } else {
                    System.out.println("Il nome del server deve essere nella forma IP:PORT");
                    continue;
                } //if-else
                rightServer = true;
                try {
                    sock = new Socket(addr, port);
                    out = new DataOutputStream(sock.getOutputStream());
                    in = new DataInputStream(sock.getInputStream());
                } catch (IOException ioex) {
                    System.out.println("Errore nella creazioen socket, termino");
                    ioex.printStackTrace();
                    System.exit(1);
                } //try-catch
            } catch (UnknownHostException uhex) {
                System.out.println("IP non riconosciuto");
                continue;
            } catch (IOException ioex) {
                System.out.println("Errore nella lettura stringa");
                continue;
            } catch (NumberFormatException nfex) {
                System.out.println("Porta non valida, deve essere un intero tra 0 e 65535");
                continue;
            } //try-catch
        } //while// </editor-fold>
        while (true) {
            String nomeDirettorio = "";
            String getPut = "";
            //<editor-fold defaultstate="collapsed" desc="Lettura nome direttorio e operazione">
            boolean otherDirectories = true;
            boolean rightDirectoryName = false;
            boolean rightOperation = false;
            while (!rightOperation) {
                System.out.println("Vuoi Uploadare o Downloadare una cartella? GET / PUT / invio per uscire");
                BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
                try {
                    getPut = br.readLine();
                    if (getPut.length() == 0) {
                        otherDirectories = false;
                        nomeDirettorio = "";
                    } //if
                } catch (IOException ioex) {
                    System.out.println("Scegli SET o PUT, invio per terminare");
                } //try-catch
                rightOperation = true;
            } //while(rightOperation)
            if(!otherDirectories) rightDirectoryName = true;
            while (!rightDirectoryName) {
                System.out.println("Da che direttorio vuoi leggere? Invio per terminare");
                BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
                try {
                    nomeDirettorio = br.readLine();
                    if (nomeDirettorio.length() == 0) {
                        otherDirectories = false;
                        nomeDirettorio = "";
                    } //if
                } catch (IOException ioex) {
                    System.out.println("Nome file non valido");
                } //try-catch
                rightDirectoryName = true;
            } //while(rightDirectoryName) //</editor-fold>
            //<editor-fold defaultstate="collapsed" desc="Protocollo comunicazione">
            /*
             * Protocollo richiesta:
             *     invio al server GETDIR:"nomeDir" se voglio scaricare una cartella
             *     invio al server PUTDIR:"nomeDir" se voglio caricare una cartella
             *         il protocollo è lo stesso che in ricezione
             *     invio OFF se non voglio altro e posso chiudere la connessione
             * Protocollo risposta dal server:
             *     ricevo "" se direttorio inesistente
             *     ricevo ciclicamente "nomefile":NUMBYTE:stream se il direttorio
             *       c'e' e "" quando i file finiscono.
             */ //</editor-fold>
            try {
                String toSend;
                if (nomeDirettorio.length() == 0) toSend = "OFF";
                else if(getPut.equals("GET")) toSend = "GETDIR:" + nomeDirettorio;
                else if(getPut.equals("PUT")) toSend = "PUTDIR:" + nomeDirettorio;
                else{
                    System.out.println("Errore nella scelta dell'operazione, termino");
                    break;
                } //if-else
                if(!sock.isBound()){
                    System.out.println("Errore comunicaione col server");
                    break;
                } //if
                out.writeUTF(toSend);
                out.flush();
                //se l'utente ha scelto di terminare il programma termina qui
                if (!otherDirectories) break;
                if(getPut.equals("GET")){
                    //<editor-fold defaultstate="collapsed" desc="Lettura directory">
                    boolean everReceived = false;
                    while (true) {
                        String toReceive = in.readUTF();
                        if (toReceive.length() == 0 && everReceived) {
                            break;
                        } else if (toReceive.length() == 0 && !everReceived) {
                            System.out.println("Directory inesistente");
                            break;
                        } //if-else
                        everReceived = true;
                        StringTokenizer str = new StringTokenizer(toReceive, ":");
                        File actualDir = new File(nomeDirettorio);
                        actualDir.mkdir();
                        String localPath = nomeDirettorio+java.io.File.separatorChar+str.nextToken();
                        DataOutputStream fOut = new DataOutputStream(new FileOutputStream(localPath));
                        int dim = Integer.parseInt(str.nextToken());
                        for (int i = 0; i < dim; i++) {
                            fOut.write(in.read());
                        } //for(dim)
                        fOut.close();
                    } //while(true) //</editor-fold>
                } else {
                    //<editor-fold defaultstate="collapsed" desc="Invio directory">
                    File f = new File(nomeDirettorio);
                    if (!f.isDirectory()) {
                        System.out.println("Directory non valida");
                        break;
                    } //if
                    for (int i = 0; i < f.listFiles().length; i++) {
                        File temp = f.listFiles()[i];
                        out.writeUTF(temp.getName() + ":" + temp.length());
                        DataInputStream fIn = new DataInputStream(new FileInputStream(temp));
                        for (int c = 0; c < temp.length(); c++) {
                            out.write(fIn.read());
                            out.flush();
                        } //for
                        fIn.close();
                    } //for
                    out.writeUTF("");
                    out.flush(); //</editor-fold>
                } //if-else
            } catch (Exception e) {
                e.printStackTrace();
            } //try-catch
        } //while(true)
        //<editor-fold defaultstate="collapsed" desc="terminazione">
        try {
            out.close();
            in.close();
            if (!sock.isClosed()) {
                sock.shutdownInput();
                sock.close();
            } //if
        } catch (IOException ioex) {
            System.out.println("Errore di chiusura, termino");
            ioex.printStackTrace();
            System.exit(1);
        } //try-catch //</editor-fold>
    } //main
} //class
